a3b6f988229c6f412fb4309a34a0a22c1c84c27c
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_STUCKLONG=
   8OPTIONS_SPEC="\
   9git am [options] [(<mbox>|<Maildir>)...]
  10git am [options] (--continue | --skip | --abort)
  11--
  12i,interactive   run interactively
  13b,binary*       (historical option -- no-op)
  143,3way          allow fall back on 3way merging if needed
  15q,quiet         be quiet
  16s,signoff       add a Signed-off-by line to the commit message
  17u,utf8          recode into utf8 (default)
  18k,keep          pass -k flag to git-mailinfo
  19keep-non-patch  pass -b flag to git-mailinfo
  20keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  21no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  22c,scissors      strip everything before a scissors line
  23whitespace=     pass it through git-apply
  24ignore-space-change pass it through git-apply
  25ignore-whitespace pass it through git-apply
  26directory=      pass it through git-apply
  27exclude=        pass it through git-apply
  28include=        pass it through git-apply
  29C=              pass it through git-apply
  30p=              pass it through git-apply
  31patch-format=   format the patch(es) are in
  32reject          pass it through git-apply
  33resolvemsg=     override error message when patch failure occurs
  34continue        continue applying patches after resolving a conflict
  35r,resolved      synonyms for --continue
  36skip            skip the current patch
  37abort           restore the original branch and abort the patching operation.
  38committer-date-is-author-date    lie about committer date
  39ignore-date     use current timestamp for author date
  40rerere-autoupdate update the index with reused conflict resolution if possible
  41rebasing*       (internal use for git-rebase)"
  42
  43. git-sh-setup
  44. git-sh-i18n
  45prefix=$(git rev-parse --show-prefix)
  46set_reflog_action am
  47require_work_tree
  48cd_to_toplevel
  49
  50git var GIT_COMMITTER_IDENT >/dev/null ||
  51        die "$(gettext "You need to set your committer info first")"
  52
  53if git rev-parse --verify -q HEAD >/dev/null
  54then
  55        HAS_HEAD=yes
  56else
  57        HAS_HEAD=
  58fi
  59
  60cmdline="git am"
  61if test '' != "$interactive"
  62then
  63        cmdline="$cmdline -i"
  64fi
  65if test '' != "$threeway"
  66then
  67        cmdline="$cmdline -3"
  68fi
  69
  70sq () {
  71        git rev-parse --sq-quote "$@"
  72}
  73
  74stop_here () {
  75    echo "$1" >"$dotest/next"
  76    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  77    exit 1
  78}
  79
  80safe_to_abort () {
  81        if test -f "$dotest/dirtyindex"
  82        then
  83                return 1
  84        fi
  85
  86        if ! test -s "$dotest/abort-safety"
  87        then
  88                return 0
  89        fi
  90
  91        abort_safety=$(cat "$dotest/abort-safety")
  92        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  93        then
  94                return 0
  95        fi
  96        gettextln "You seem to have moved HEAD since the last 'am' failure.
  97Not rewinding to ORIG_HEAD" >&2
  98        return 1
  99}
 100
 101stop_here_user_resolve () {
 102    if [ -n "$resolvemsg" ]; then
 103            printf '%s\n' "$resolvemsg"
 104            stop_here $1
 105    fi
 106    eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
 107If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
 108To restore the original branch and stop patching, run \"\$cmdline --abort\"."
 109
 110    stop_here $1
 111}
 112
 113go_next () {
 114        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 115                "$dotest/patch" "$dotest/info"
 116        echo "$next" >"$dotest/next"
 117        this=$next
 118}
 119
 120cannot_fallback () {
 121        echo "$1"
 122        gettextln "Cannot fall back to three-way merge."
 123        exit 1
 124}
 125
 126fall_back_3way () {
 127    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 128
 129    rm -fr "$dotest"/patch-merge-*
 130    mkdir "$dotest/patch-merge-tmp-dir"
 131
 132    # First see if the patch records the index info that we can use.
 133    cmd="git apply $git_apply_opt --build-fake-ancestor" &&
 134    cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
 135    eval "$cmd" &&
 136    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 137    git write-tree >"$dotest/patch-merge-base+" ||
 138    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 139
 140    say "$(gettext "Using index info to reconstruct a base tree...")"
 141
 142    cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
 143
 144    if test -z "$GIT_QUIET"
 145    then
 146        eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
 147    fi
 148
 149    cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
 150    if eval "$cmd"
 151    then
 152        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 153        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 154    else
 155        cannot_fallback "$(gettext "Did you hand edit your patch?
 156It does not apply to blobs recorded in its index.")"
 157    fi
 158
 159    test -f "$dotest/patch-merge-index" &&
 160    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 161    orig_tree=$(cat "$dotest/patch-merge-base") &&
 162    rm -fr "$dotest"/patch-merge-* || exit 1
 163
 164    say "$(gettext "Falling back to patching base and 3-way merge...")"
 165
 166    # This is not so wrong.  Depending on which base we picked,
 167    # orig_tree may be wildly different from ours, but his_tree
 168    # has the same set of wildly different changes in parts the
 169    # patch did not touch, so recursive ends up canceling them,
 170    # saying that we reverted all those changes.
 171
 172    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 173    export GITHEAD_$his_tree
 174    if test -n "$GIT_QUIET"
 175    then
 176            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 177    fi
 178    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 179            git rerere $allow_rerere_autoupdate
 180            die "$(gettext "Failed to merge in the changes.")"
 181    }
 182    unset GITHEAD_$his_tree
 183}
 184
 185clean_abort () {
 186        test $# = 0 || echo >&2 "$@"
 187        rm -fr "$dotest"
 188        exit 1
 189}
 190
 191patch_format=
 192
 193check_patch_format () {
 194        # early return if patch_format was set from the command line
 195        if test -n "$patch_format"
 196        then
 197                return 0
 198        fi
 199
 200        # we default to mbox format if input is from stdin and for
 201        # directories
 202        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 203        then
 204                patch_format=mbox
 205                return 0
 206        fi
 207
 208        # otherwise, check the first few non-blank lines of the first
 209        # patch to try to detect its format
 210        {
 211                # Start from first line containing non-whitespace
 212                l1=
 213                while test -z "$l1"
 214                do
 215                        read l1 || break
 216                done
 217                read l2
 218                read l3
 219                case "$l1" in
 220                "From "* | "From: "*)
 221                        patch_format=mbox
 222                        ;;
 223                '# This series applies on GIT commit'*)
 224                        patch_format=stgit-series
 225                        ;;
 226                "# HG changeset patch")
 227                        patch_format=hg
 228                        ;;
 229                *)
 230                        # if the second line is empty and the third is
 231                        # a From, Author or Date entry, this is very
 232                        # likely an StGIT patch
 233                        case "$l2,$l3" in
 234                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 235                                patch_format=stgit
 236                                ;;
 237                        *)
 238                                ;;
 239                        esac
 240                        ;;
 241                esac
 242                if test -z "$patch_format" &&
 243                        test -n "$l1" &&
 244                        test -n "$l2" &&
 245                        test -n "$l3"
 246                then
 247                        # This begins with three non-empty lines.  Is this a
 248                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 249                        # discarding the indented remainder of folded lines,
 250                        # and see if it looks like that they all begin with the
 251                        # header field names...
 252                        tr -d '\015' <"$1" |
 253                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 254                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 255                        patch_format=mbox
 256                fi
 257        } < "$1" || clean_abort
 258}
 259
 260split_patches () {
 261        case "$patch_format" in
 262        mbox)
 263                if test t = "$keepcr"
 264                then
 265                    keep_cr=--keep-cr
 266                else
 267                    keep_cr=
 268                fi
 269                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 270                clean_abort
 271                ;;
 272        stgit-series)
 273                if test $# -ne 1
 274                then
 275                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 276                fi
 277                series_dir=`dirname "$1"`
 278                series_file="$1"
 279                shift
 280                {
 281                        set x
 282                        while read filename
 283                        do
 284                                set "$@" "$series_dir/$filename"
 285                        done
 286                        # remove the safety x
 287                        shift
 288                        # remove the arg coming from the first-line comment
 289                        shift
 290                } < "$series_file" || clean_abort
 291                # set the patch format appropriately
 292                patch_format=stgit
 293                # now handle the actual StGIT patches
 294                split_patches "$@"
 295                ;;
 296        stgit)
 297                this=0
 298                for stgit in "$@"
 299                do
 300                        this=`expr "$this" + 1`
 301                        msgnum=`printf "%0${prec}d" $this`
 302                        # Perl version of StGIT parse_patch. The first nonemptyline
 303                        # not starting with Author, From or Date is the
 304                        # subject, and the body starts with the next nonempty
 305                        # line not starting with Author, From or Date
 306                        @@PERL@@ -ne 'BEGIN { $subject = 0 }
 307                                if ($subject > 1) { print ; }
 308                                elsif (/^\s+$/) { next ; }
 309                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 310                                elsif (/^(From|Date)/) { print ; }
 311                                elsif ($subject) {
 312                                        $subject = 2 ;
 313                                        print "\n" ;
 314                                        print ;
 315                                } else {
 316                                        print "Subject: ", $_ ;
 317                                        $subject = 1;
 318                                }
 319                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 320                done
 321                echo "$this" > "$dotest/last"
 322                this=
 323                msgnum=
 324                ;;
 325        hg)
 326                this=0
 327                for hg in "$@"
 328                do
 329                        this=$(( $this + 1 ))
 330                        msgnum=$(printf "%0${prec}d" $this)
 331                        # hg stores changeset metadata in #-commented lines preceding
 332                        # the commit message and diff(s). The only metadata we care about
 333                        # are the User and Date (Node ID and Parent are hashes which are
 334                        # only relevant to the hg repository and thus not useful to us)
 335                        # Since we cannot guarantee that the commit message is in
 336                        # git-friendly format, we put no Subject: line and just consume
 337                        # all of the message as the body
 338                        LANG=C LC_ALL=C @@PERL@@ -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 339                                if ($subject) { print ; }
 340                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 341                                elsif (/^\# Date /) {
 342                                        my ($hashsign, $str, $time, $tz) = split ;
 343                                        $tz = sprintf "%+05d", (0-$tz)/36;
 344                                        print "Date: " .
 345                                              strftime("%a, %d %b %Y %H:%M:%S ",
 346                                                       localtime($time))
 347                                              . "$tz\n";
 348                                } elsif (/^\# /) { next ; }
 349                                else {
 350                                        print "\n", $_ ;
 351                                        $subject = 1;
 352                                }
 353                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 354                done
 355                echo "$this" >"$dotest/last"
 356                this=
 357                msgnum=
 358                ;;
 359        *)
 360                if test -n "$patch_format"
 361                then
 362                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 363                else
 364                        clean_abort "$(gettext "Patch format detection failed.")"
 365                fi
 366                ;;
 367        esac
 368}
 369
 370prec=4
 371dotest="$GIT_DIR/rebase-apply"
 372sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 373resolvemsg= resume= scissors= no_inbody_headers=
 374git_apply_opt=
 375committer_date_is_author_date=
 376ignore_date=
 377allow_rerere_autoupdate=
 378
 379if test "$(git config --bool --get am.keepcr)" = true
 380then
 381    keepcr=t
 382fi
 383
 384while test $# != 0
 385do
 386        case "$1" in
 387        -i|--interactive)
 388                interactive=t ;;
 389        -b|--binary)
 390                gettextln >&2 "The -b/--binary option has been a no-op for long time, and
 391it will be removed. Please do not use it anymore."
 392                ;;
 393        -3|--3way)
 394                threeway=t ;;
 395        -s|--signoff)
 396                sign=t ;;
 397        -u|--utf8)
 398                utf8=t ;; # this is now default
 399        --no-utf8)
 400                utf8= ;;
 401        -k|--keep)
 402                keep=t ;;
 403        --keep-non-patch)
 404                keep=b ;;
 405        -c|--scissors)
 406                scissors=t ;;
 407        --no-scissors)
 408                scissors=f ;;
 409        -r|--resolved|--continue)
 410                resolved=t ;;
 411        --skip)
 412                skip=t ;;
 413        --abort)
 414                abort=t ;;
 415        --rebasing)
 416                rebasing=t threeway=t ;;
 417        --resolvemsg)
 418                shift; resolvemsg=$1 ;;
 419        --whitespace|--directory|--exclude|--include)
 420                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 421        -C|-p)
 422                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 423        --patch-format)
 424                shift ; patch_format="$1" ;;
 425        --reject|--ignore-whitespace|--ignore-space-change)
 426                git_apply_opt="$git_apply_opt $1" ;;
 427        --committer-date-is-author-date)
 428                committer_date_is_author_date=t ;;
 429        --ignore-date)
 430                ignore_date=t ;;
 431        --rerere-autoupdate|--no-rerere-autoupdate)
 432                allow_rerere_autoupdate="$1" ;;
 433        -q|--quiet)
 434                GIT_QUIET=t ;;
 435        --keep-cr)
 436                keepcr=t ;;
 437        --no-keep-cr)
 438                keepcr=f ;;
 439        --)
 440                shift; break ;;
 441        *)
 442                usage ;;
 443        esac
 444        shift
 445done
 446
 447# If the dotest directory exists, but we have finished applying all the
 448# patches in them, clear it out.
 449if test -d "$dotest" &&
 450   test -f "$dotest/last" &&
 451   test -f "$dotest/next" &&
 452   last=$(cat "$dotest/last") &&
 453   next=$(cat "$dotest/next") &&
 454   test $# != 0 &&
 455   test "$next" -gt "$last"
 456then
 457   rm -fr "$dotest"
 458fi
 459
 460if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
 461then
 462        case "$#,$skip$resolved$abort" in
 463        0,*t*)
 464                # Explicit resume command and we do not have file, so
 465                # we are happy.
 466                : ;;
 467        0,)
 468                # No file input but without resume parameters; catch
 469                # user error to feed us a patch from standard input
 470                # when there is already $dotest.  This is somewhat
 471                # unreliable -- stdin could be /dev/null for example
 472                # and the caller did not intend to feed us a patch but
 473                # wanted to continue unattended.
 474                test -t 0
 475                ;;
 476        *)
 477                false
 478                ;;
 479        esac ||
 480        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 481        resume=yes
 482
 483        case "$skip,$abort" in
 484        t,t)
 485                die "$(gettext "Please make up your mind. --skip or --abort?")"
 486                ;;
 487        t,)
 488                git rerere clear
 489                git read-tree --reset -u HEAD HEAD
 490                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 491                git reset HEAD
 492                git update-ref ORIG_HEAD $orig_head
 493                ;;
 494        ,t)
 495                if test -f "$dotest/rebasing"
 496                then
 497                        exec git rebase --abort
 498                fi
 499                git rerere clear
 500                if safe_to_abort
 501                then
 502                        git read-tree --reset -u HEAD ORIG_HEAD
 503                        git reset ORIG_HEAD
 504                fi
 505                rm -fr "$dotest"
 506                exit ;;
 507        esac
 508        rm -f "$dotest/dirtyindex"
 509else
 510        # Possible stray $dotest directory in the independent-run
 511        # case; in the --rebasing case, it is upto the caller
 512        # (git-rebase--am) to take care of stray directories.
 513        if test -d "$dotest" && test -z "$rebasing"
 514        then
 515                case "$skip,$resolved,$abort" in
 516                ,,t)
 517                        rm -fr "$dotest"
 518                        exit 0
 519                        ;;
 520                *)
 521                        die "$(eval_gettext "Stray \$dotest directory found.
 522Use \"git am --abort\" to remove it.")"
 523                        ;;
 524                esac
 525        fi
 526
 527        # Make sure we are not given --skip, --continue, nor --abort
 528        test "$skip$resolved$abort" = "" ||
 529                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 530
 531        # Start afresh.
 532        mkdir -p "$dotest" || exit
 533
 534        if test -n "$prefix" && test $# != 0
 535        then
 536                first=t
 537                for arg
 538                do
 539                        test -n "$first" && {
 540                                set x
 541                                first=
 542                        }
 543                        if is_absolute_path "$arg"
 544                        then
 545                                set "$@" "$arg"
 546                        else
 547                                set "$@" "$prefix$arg"
 548                        fi
 549                done
 550                shift
 551        fi
 552
 553        check_patch_format "$@"
 554
 555        split_patches "$@"
 556
 557        # -i can and must be given when resuming; everything
 558        # else is kept
 559        echo " $git_apply_opt" >"$dotest/apply-opt"
 560        echo "$threeway" >"$dotest/threeway"
 561        echo "$sign" >"$dotest/sign"
 562        echo "$utf8" >"$dotest/utf8"
 563        echo "$keep" >"$dotest/keep"
 564        echo "$scissors" >"$dotest/scissors"
 565        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 566        echo "$GIT_QUIET" >"$dotest/quiet"
 567        echo 1 >"$dotest/next"
 568        if test -n "$rebasing"
 569        then
 570                : >"$dotest/rebasing"
 571        else
 572                : >"$dotest/applying"
 573                if test -n "$HAS_HEAD"
 574                then
 575                        git update-ref ORIG_HEAD HEAD
 576                else
 577                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 578                fi
 579        fi
 580fi
 581
 582git update-index -q --refresh
 583
 584case "$resolved" in
 585'')
 586        case "$HAS_HEAD" in
 587        '')
 588                files=$(git ls-files) ;;
 589        ?*)
 590                files=$(git diff-index --cached --name-only HEAD --) ;;
 591        esac || exit
 592        if test "$files"
 593        then
 594                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 595                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 596        fi
 597esac
 598
 599# Now, decide what command line options we will give to the git
 600# commands we invoke, based on the result of parsing command line
 601# options and previous invocation state stored in $dotest/ files.
 602
 603if test "$(cat "$dotest/utf8")" = t
 604then
 605        utf8=-u
 606else
 607        utf8=-n
 608fi
 609keep=$(cat "$dotest/keep")
 610case "$keep" in
 611t)
 612        keep=-k ;;
 613b)
 614        keep=-b ;;
 615*)
 616        keep= ;;
 617esac
 618case "$(cat "$dotest/scissors")" in
 619t)
 620        scissors=--scissors ;;
 621f)
 622        scissors=--no-scissors ;;
 623esac
 624if test "$(cat "$dotest/no_inbody_headers")" = t
 625then
 626        no_inbody_headers=--no-inbody-headers
 627else
 628        no_inbody_headers=
 629fi
 630if test "$(cat "$dotest/quiet")" = t
 631then
 632        GIT_QUIET=t
 633fi
 634if test "$(cat "$dotest/threeway")" = t
 635then
 636        threeway=t
 637fi
 638git_apply_opt=$(cat "$dotest/apply-opt")
 639if test "$(cat "$dotest/sign")" = t
 640then
 641        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 642                        s/>.*/>/
 643                        s/^/Signed-off-by: /'
 644                `
 645else
 646        SIGNOFF=
 647fi
 648
 649last=`cat "$dotest/last"`
 650this=`cat "$dotest/next"`
 651if test "$skip" = t
 652then
 653        this=`expr "$this" + 1`
 654        resume=
 655fi
 656
 657while test "$this" -le "$last"
 658do
 659        msgnum=`printf "%0${prec}d" $this`
 660        next=`expr "$this" + 1`
 661        test -f "$dotest/$msgnum" || {
 662                resume=
 663                go_next
 664                continue
 665        }
 666
 667        # If we are not resuming, parse and extract the patch information
 668        # into separate files:
 669        #  - info records the authorship and title
 670        #  - msg is the rest of commit log message
 671        #  - patch is the patch body.
 672        #
 673        # When we are resuming, these files are either already prepared
 674        # by the user, or the user can tell us to do so by --continue flag.
 675        case "$resume" in
 676        '')
 677                if test -f "$dotest/rebasing"
 678                then
 679                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 680                                -e q "$dotest/$msgnum") &&
 681                        test "$(git cat-file -t "$commit")" = commit ||
 682                                stop_here $this
 683                        git cat-file commit "$commit" |
 684                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 685                        echo "$commit" >"$dotest/original-commit"
 686                        get_author_ident_from_commit "$commit" >"$dotest/author-script"
 687                        git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
 688                else
 689                        git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 690                                <"$dotest/$msgnum" >"$dotest/info" ||
 691                                stop_here $this
 692
 693                        # skip pine's internal folder data
 694                        sane_grep '^Author: Mail System Internal Data$' \
 695                                <"$dotest"/info >/dev/null &&
 696                                go_next && continue
 697
 698                        test -s "$dotest/patch" || {
 699                                eval_gettextln "Patch is empty.  Was it split wrong?
 700If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 701To restore the original branch and stop patching run \"\$cmdline --abort\"."
 702                                stop_here $this
 703                        }
 704                        rm -f "$dotest/original-commit" "$dotest/author-script"
 705                        {
 706                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 707                                echo
 708                                cat "$dotest/msg"
 709                        } |
 710                        git stripspace > "$dotest/msg-clean"
 711                fi
 712                ;;
 713        esac
 714
 715        if test -f "$dotest/author-script"
 716        then
 717                eval $(cat "$dotest/author-script")
 718        else
 719                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 720                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 721                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 722        fi
 723
 724        if test -z "$GIT_AUTHOR_EMAIL"
 725        then
 726                gettextln "Patch does not have a valid e-mail address."
 727                stop_here $this
 728        fi
 729
 730        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 731
 732        case "$resume" in
 733        '')
 734            if test '' != "$SIGNOFF"
 735            then
 736                LAST_SIGNED_OFF_BY=`
 737                    sed -ne '/^Signed-off-by: /p' \
 738                    "$dotest/msg-clean" |
 739                    sed -ne '$p'
 740                `
 741                ADD_SIGNOFF=`
 742                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 743                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 744                    echo "$SIGNOFF"
 745                }`
 746            else
 747                ADD_SIGNOFF=
 748            fi
 749            {
 750                if test -s "$dotest/msg-clean"
 751                then
 752                        cat "$dotest/msg-clean"
 753                fi
 754                if test '' != "$ADD_SIGNOFF"
 755                then
 756                        echo "$ADD_SIGNOFF"
 757                fi
 758            } >"$dotest/final-commit"
 759            ;;
 760        *)
 761                case "$resolved$interactive" in
 762                tt)
 763                        # This is used only for interactive view option.
 764                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 765                        ;;
 766                esac
 767        esac
 768
 769        resume=
 770        if test "$interactive" = t
 771        then
 772            test -t 0 ||
 773            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 774            action=again
 775            while test "$action" = again
 776            do
 777                gettextln "Commit Body is:"
 778                echo "--------------------------"
 779                cat "$dotest/final-commit"
 780                echo "--------------------------"
 781                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 782                # in your translation. The program will only accept English
 783                # input at this point.
 784                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 785                read reply
 786                case "$reply" in
 787                [yY]*) action=yes ;;
 788                [aA]*) action=yes interactive= ;;
 789                [nN]*) action=skip ;;
 790                [eE]*) git_editor "$dotest/final-commit"
 791                       action=again ;;
 792                [vV]*) action=again
 793                       git_pager "$dotest/patch" ;;
 794                *)     action=again ;;
 795                esac
 796            done
 797        else
 798            action=yes
 799        fi
 800
 801        if test $action = skip
 802        then
 803                go_next
 804                continue
 805        fi
 806
 807        if test -x "$GIT_DIR"/hooks/applypatch-msg
 808        then
 809                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 810                stop_here $this
 811        fi
 812
 813        if test -f "$dotest/final-commit"
 814        then
 815                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 816        else
 817                FIRSTLINE=""
 818        fi
 819
 820        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 821
 822        case "$resolved" in
 823        '')
 824                # When we are allowed to fall back to 3-way later, don't give
 825                # false errors during the initial attempt.
 826                squelch=
 827                if test "$threeway" = t
 828                then
 829                        squelch='>/dev/null 2>&1 '
 830                fi
 831                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 832                apply_status=$?
 833                ;;
 834        t)
 835                # Resolved means the user did all the hard work, and
 836                # we do not have to do any patch application.  Just
 837                # trust what the user has in the index file and the
 838                # working tree.
 839                resolved=
 840                git diff-index --quiet --cached HEAD -- && {
 841                        gettextln "No changes - did you forget to use 'git add'?
 842If there is nothing left to stage, chances are that something else
 843already introduced the same changes; you might want to skip this patch."
 844                        stop_here_user_resolve $this
 845                }
 846                unmerged=$(git ls-files -u)
 847                if test -n "$unmerged"
 848                then
 849                        gettextln "You still have unmerged paths in your index
 850did you forget to use 'git add'?"
 851                        stop_here_user_resolve $this
 852                fi
 853                apply_status=0
 854                git rerere
 855                ;;
 856        esac
 857
 858        if test $apply_status != 0 && test "$threeway" = t
 859        then
 860                if (fall_back_3way)
 861                then
 862                    # Applying the patch to an earlier tree and merging the
 863                    # result may have produced the same tree as ours.
 864                    git diff-index --quiet --cached HEAD -- && {
 865                        say "$(gettext "No changes -- Patch already applied.")"
 866                        go_next
 867                        continue
 868                    }
 869                    # clear apply_status -- we have successfully merged.
 870                    apply_status=0
 871                fi
 872        fi
 873        if test $apply_status != 0
 874        then
 875                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 876                if test "$(git config --bool advice.amworkdir)" != false
 877                then
 878                        eval_gettextln 'The copy of the patch that failed is found in:
 879   $dotest/patch'
 880                fi
 881                stop_here_user_resolve $this
 882        fi
 883
 884        if test -x "$GIT_DIR"/hooks/pre-applypatch
 885        then
 886                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 887        fi
 888
 889        tree=$(git write-tree) &&
 890        commit=$(
 891                if test -n "$ignore_date"
 892                then
 893                        GIT_AUTHOR_DATE=
 894                fi
 895                parent=$(git rev-parse --verify -q HEAD) ||
 896                say >&2 "$(gettext "applying to an empty history")"
 897
 898                if test -n "$committer_date_is_author_date"
 899                then
 900                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 901                        export GIT_COMMITTER_DATE
 902                fi &&
 903                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 904        ) &&
 905        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 906        stop_here $this
 907
 908        if test -f "$dotest/original-commit"; then
 909                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 910        fi
 911
 912        if test -x "$GIT_DIR"/hooks/post-applypatch
 913        then
 914                "$GIT_DIR"/hooks/post-applypatch
 915        fi
 916
 917        go_next
 918done
 919
 920if test -s "$dotest"/rewritten; then
 921    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 922    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 923        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 924    fi
 925fi
 926
 927# If am was called with --rebasing (from git-rebase--am), it's up to
 928# the caller to take care of housekeeping.
 929if ! test -f "$dotest/rebasing"
 930then
 931        rm -fr "$dotest"
 932        git gc --auto
 933fi